# Frontend attack processing scipt

# Usage: see README (step 3) in the top level 
# Authors: 
# Shuwen Deng (shuwen.deng@yale.edu)
# Bowen Huang (bowen.huang@yale.edu)
# Jakub Szefer (jakub.szefer@yale.edu)
import matplotlib
matplotlib.use('Agg')

import numpy as np
import pandas as pd
#from sklearn import linear_model
import matplotlib.pyplot as plt
import sys
from scipy.spatial import distance


ifplot=1
columnnum=1
judge_1_standard=0.3 
success_run_standard=0.8
filename=sys.argv[1] 
f_write = open(filename[:-4]+'_output.txt', "a", buffering=1)
print("filename:", filename[:-4]+'_output.txt')
f_write.write("filename: " + filename + "\n")
repeat_time=int(sys.argv[2]) #30
d_trials=int(sys.argv[3]) #1
loop_time=int(sys.argv[4])*2 #500
input_bit_type=2 #int(sys.argv[5]) # 0: all 0; 1: all 1; 2: 101010; 3: random
timing_array=[[[] for i in range(repeat_time)] for j in range(d_trials)]
seconds_array=[[0 for i in range(repeat_time)] for j in range(d_trials)]

sample_array_0=[0 for i in range(loop_time)] 
sample_array_1=[1 for i in range(loop_time)] 
sample_array_0_1=([0] + [1])*loop_time
sample_array_r=[[[] for i in range(repeat_time)] for j in range(d_trials)] 
sample_array_final=sample_array_0
if input_bit_type==1:
    sample_array_final = sample_array_1
elif input_bit_type==2:
    sample_array_final = sample_array_0_1
elif input_bit_type==3:
    sample_array_final = sample_array_r


for i in range(d_trials):
    for j in range(repeat_time):
        sample_array_r[i][j]=sample_array_r[0][0]


counter=0
with open(filename) as infile:
    d_number=-1;repeat_number=-1;
    for line in infile:            #Iterate each line
        line = line.strip().split("\t")        #strip new line
        if "acc" in line[0] and len(line[0].split("_"))>3: 
            # print(line[0])
            d_number=int(line[0].split("_")[3])-1 
        if "repeat" in line[0]:
            repeat_number=int(line[0].split("_")[1])-1
        if len(line)==2: 
            timing_array[d_number][repeat_number].append(int(line[1]))
        if len(line)>10:
            seconds_array[d_number][repeat_number]=float(line[-1]) 
        counter+=1

matplotlib.rcParams.update({'font.size': 29})

N = 50
x = [i for i in range(len(timing_array[d_trials-1][0]))]


try: 
    # use numpy arrays if possible...
    from numpy import zeros
    def _zeros(*shape):
        """ like this syntax better...a la MATLAB """
        return zeros(shape)
except ImportError:
    # otherwise do this cute solution
    def _zeros(*shape):
        """ LISPy """
        if len(shape) == 0: 
            return 0 
        car = shape[0] 
        cdr = shape[1:] 
        return [my_zeros(*cdr) for i in range(car)] 


def WagnerFischer(A, B, insertion=1, deletion=1, substitution=2):
    """ 
    Strings are input as A and B. Costs can be optionally given. Matches are 
    always free. Returns A and B plus a list of characters indicating 
    insertion, deletion, or substitution.
    
    >>> print WagnerFischer('abcd', 'abxcd')
    ('ab*cd', 'abxcd', '==^==')
    >>> print WagnerFischer('unfreakingbelievable', 'unbelievable')
    ('unfreakingbelievable', 'un********believable', '==vvvvvvvv==========')
    """
    A = list(A) # will perform insertion of these...so has to be a list
    B = list(B)
    n_A = len(A)
    n_B = len(B)
    # compute distance matrix
    D = _zeros(n_A + 1, n_B + 1)
    for i in xrange(n_A): # cost of deletion
        D[i + 1][0] = D[i][0] + deletion 
    for j in xrange(n_B): # cost of insertion
        D[0][j + 1] = D[0][j] + insertion 
    for i in xrange(n_A): # fill out middle of matrix 
        for j in xrange(n_B): # fill out matrix # 1
            if A[i] == B[j]: # match
                D[i + 1][j + 1] = D[i][j] # aka, it's free. 
            else: # no match
                D[i + 1][j + 1] = min(D[i + 1][j] + insertion,
                                      D[i][j + 1] + deletion, 
                                      D[i][j]     + substitution) 
    # traceback
    change = []
    while n_A > 0 and n_B > 0:
        s_cost = D[n_A][n_B]     # substitute or match
        d_cost = D[n_A - 1][n_B] # delete
        i_cost = D[n_A][n_B - 1] # insert
        if s_cost < d_cost:
            if s_cost < i_cost:
                if s_cost == D[n_A][n_B]: # match
                    change.append('=') 
                else: # substitution
                    change.append('*')
                n_A -= 1
                n_B -= 1
            else: # insertion
                change.append('^')
                A.insert(n_A, '*') # 1
                n_B -= 1
        else: # deletion
            change.append('v')
            B.insert(n_B, '*') # 1
            n_A -= 1
    # final_arr = ''.join(change[::-1])
    # print (final_arr, change[::-1].count('*') + change[::-1].count('^') + change[::-1].count('v'))
    # print (change[::-1])
    err_rate = float((change[::-1].count('*') + change[::-1].count('^') + change[::-1].count('v')))/len(change[::-1])
    return 1-err_rate #''.join(A), ''.join(B), ''.join(change[::-1])

decode_number_array = [[450,550]] 


for recv_acc_way in range(d_trials-1, d_trials): 
    for repeat_way in range(repeat_time): 
        cur_trials = timing_array[recv_acc_way][repeat_way]
        np_cur_trials = np.array(cur_trials)
        mean_num=np.mean(np_cur_trials)
        best_res=[]
        best_success_rate=[0, 0, 0]
        best_transmission_res=[]
        best_transmission_rate=[0, 0, 0]
        mean_final=np.mean(np_cur_trials)
        temp_trials = timing_array[recv_acc_way][0]
        if input_bit_type==0:
            mean_final=0
            for i in range(10):
                mean_final+=np.mean(np.array(timing_array[recv_acc_way][i+2]))
            if recv_acc_way<=2:
                mean_final = mean_final/10+1500
            else:
                mean_final = mean_final/10*1.3
        elif input_bit_type==1:
            mean_final=0
            for i in range(10):
                mean_final+=np.mean(np.array(timing_array[recv_acc_way][i+2]))
            if recv_acc_way<=2:
                mean_final = mean_final/10-1500
            else:
                mean_final = mean_final/10*0.75
        if input_bit_type==3:
            sample_array_final = sample_array_r[recv_acc_way][repeat_way]
        for mean_num in [mean_final]: 
            print(mean_num)
            f_write.write(str(mean_num) + "\n")

            for decode_number in range(decode_number_array[0][0],decode_number_array[0][1]): 
                sampling_num = loop_time/decode_number
                initial_limit = sampling_num
                initial_step = (sampling_num/60+1)
                if input_bit_type==3:
                    initial_limit = 128
                    initial_step = 1
                for initial_num in range(0, initial_limit, initial_step):
                    temp_res=[]
                    for cur_sample,counter in enumerate([i for i in range(decode_number)]):
                        np_temp_trials = np.array(cur_trials[max(0, initial_num+(cur_sample)*sampling_num) : min(loop_time, initial_num+(cur_sample+1)*sampling_num)])
                        larger_num=int(((np_temp_trials>mean_num).sum())>judge_1_standard*sampling_num) 
                        temp_res.append(larger_num)

                    arr1 = (''.join([str(elem) for elem in temp_res]))
                    arr2 = (''.join([str(elem) for elem in sample_array_final[0:len(temp_res)]]))
                    temp_success_rate=WagnerFischer(arr1, arr2) #, 1, 1, 2)
                    if float((np.array([int(temp_res[i]==sample_array_final[i+1]) for i in range(len(temp_res))])==1).sum())/len(temp_res)>temp_success_rate:
                        temp_success_rate=float((np.array([int(temp_res[i]==sample_array_final[i+1]) for i in range(len(temp_res))])==1).sum())/len(temp_res)
                    ori_temp_res=temp_res
                    for sync_num in range(1,len(temp_res)):
                        impr_res=ori_temp_res[0:sync_num]+ori_temp_res[sync_num+1:]
                        if float((np.array([int(impr_res[i]==sample_array_final[i+1]) for i in range(len(impr_res))])==1).sum())/len(impr_res)>temp_success_rate:
                            temp_success_rate=float((np.array([int(impr_res[i]==sample_array_final[i+1]) for i in range(len(impr_res))])==1).sum())/len(impr_res)
                            temp_res=impr_res

                    if temp_success_rate>success_run_standard:
                        if temp_success_rate >= best_success_rate[0]:
                            best_success_rate[0] = temp_success_rate
                            best_success_rate[1] = initial_num
                            best_success_rate[2] = sampling_num
                            best_res = temp_res
                        if temp_success_rate*len(temp_res) >= best_success_rate[0]*len(best_res):
                            best_transmission_rate[0] = temp_success_rate
                            best_transmission_rate[1] = initial_num
                            best_transmission_rate[2] = sampling_num
                            best_transmission_res = temp_res


        if best_success_rate[0] > success_run_standard:
            print "Decoded results of best success: initial " + str(best_transmission_rate[1])+ ", sampling num " + str(best_transmission_rate[2]) 
            print "Recv acc way num " + str(recv_acc_way)+ ", repeat num " + \
            str(repeat_way) + ", error rate " + str(1-best_success_rate[0]) + \
            ", transmission rate " + str(float(len(best_res))/seconds_array[recv_acc_way][repeat_way]) + ", decoded number of bits", len(best_res), ": ",
            # print best_res, best_success_rate
            print str(best_success_rate[0]) + " best rate"
            print "Decoded results of best transmission: initial " + str(best_transmission_rate[1])+ ", sampling num " + str(best_transmission_rate[2])
            print "Recv acc way num " + str(recv_acc_way)+ ", repeat num " + \
            str(repeat_way) + ", error rate " + str(1-best_transmission_rate[0]) + \
            ", transmission rate " + str(float(len(best_transmission_res))/seconds_array[recv_acc_way][repeat_way]) + ", decoded number of bits", len(best_transmission_res), ": ",
            # print best_res, best_success_rate
            print best_transmission_rate[0]

            f_write.write( "Decoded results of best success: initial " + str(best_transmission_rate[1])+ ", sampling num " + str(best_transmission_rate[2]) +"\n")
            f_write.write( "Recv acc way num " + str(recv_acc_way)+ ", repeat num " + \
            str(repeat_way) + ", error rate " + str(1-best_success_rate[0]) + \
            ", transmission rate " + str(float(len(best_res))/seconds_array[recv_acc_way][repeat_way]) + ", decoded number of bits" + str(len(best_res)) + ": " + str(best_success_rate[0])+" best rate \n")
            f_write.write( "Decoded results of best transmission: initial " + str(best_transmission_rate[1])+ ", sampling num " + str(best_transmission_rate[2])+"\n")
            f_write.write( "Recv acc way num " + str(recv_acc_way)+ ", repeat num " + \
            str(repeat_way) + ", error rate " + str(1-best_transmission_rate[0]) + \
            ", transmission rate " + str(float(len(best_transmission_res))/seconds_array[recv_acc_way][repeat_way]) + ", decoded number of bits" + str(len(best_transmission_res)) + ": " + str(best_transmission_rate[0])+"\n")


                    

f_write.close()               







