# Frontend attack processing scipt

# Usage: see README (step 2) in the top level 
# Authors: 
# Shuwen Deng (shuwen.deng@yale.edu)
# Bowen Huang (bowen.huang@yale.edu)
# Jakub Szefer (jakub.szefer@yale.edu)

import numpy as np
import pandas as pd
import sys
from scipy.spatial import distance
if_multiple=0
filename=sys.argv[1][:len(sys.argv[1])-5] #"non_sgx_code/mt_stealthy_eviction_based_attack/asse_loop_data_v1_input_" 
input_bit_type=(sys.argv[2])
d_trials=int(sys.argv[3]) #1 #8 
input_machine_name=0
if if_multiple==0:
    input_machine_name=["power"] #sys.argv[3]] #["srv3", "IBM", "power"] 
elif if_multiple:
    input_machine_name=["srv3", "IBM", "power"]
input_CPU_name=["Gold 6226", "E-2174G", "E-2286G"]
bit_type_list=['0','1','a','r']

error_array=[[[] for j in range(d_trials)] for m in range(len(input_machine_name))]
trans_array=[[[] for j in range(d_trials)] for m in range(len(input_machine_name))]
taken_array=[[[] for j in range(d_trials)] for m in range(len(input_machine_name))]

avg_error_array=[[] for j in range(len(input_machine_name))]
avg_trans_array=[[] for j in range(len(input_machine_name))]
avg_effec_array=[[] for j in range(len(input_machine_name))]



for counter, machine in enumerate(input_machine_name):
    with open(filename.replace("IBM", machine)+input_bit_type+"_output.txt") as infile: #bit_type_list[counter]+"_output.txt") as infile: #input_bit_type+"_output.txt") as infile:
        d_number=-1;repeat_number=-1;
        for line in infile:            #Iterate each line
            line = line.strip().split(" ")        #strip new line
            # print(line)
            if len(line)>13:
                d_num = int(line[4][:-1])
                # print(line)
                # if d_num==2:
                #     print (line[4], line[0], line[7][:-1], line[10][:-1], line[13][:-1])
                if ("Recv" in line[0]) and (int(line[7][:-1]) not in taken_array[counter][d_num]): # and (len(taken_array[d_num])<10):
                    taken_array[counter][d_num].append(int(line[7][:-1]))
                    error_array[counter][d_num].append(float(line[10][:-1]))
                    trans_array[counter][d_num].append(float(line[13][:-1]))


sorted_error_array=[[[] for j in range(d_trials)] for m in range(len(input_machine_name))]
sorted_trans_array=[[[] for j in range(d_trials)] for m in range(len(input_machine_name))]

# print (len(sorted_error_array), len(sorted_error_array[0]), sorted_error_array[0])

for counter, machine in enumerate(input_machine_name):
    for i in range(d_trials):
        # print(error_array[i])
        sorted_index=np.argsort(error_array[counter][i])[0:5]
        for j in sorted_index: 
            sorted_error_array[counter][i].append(error_array[counter][i][j])
            sorted_trans_array[counter][i].append(trans_array[counter][i][j])

# print(sorted_trans_array[2])

for counter, machine in enumerate(input_machine_name):
    for i in range(d_trials):
        avg_error_array[counter].append(np.mean(np.array(sorted_error_array[counter][i]))) 
        avg_trans_array[counter].append(np.mean(np.array(sorted_trans_array[counter][i]))) 
        avg_effec_array[counter].append((1-np.mean(np.array(sorted_error_array[counter][i])))*np.mean(np.array(sorted_trans_array[counter][i])))  

note_texts=":"
if d_trials==8 or d_trials==7:
    note_texts=" (d=1,2,..,"+str(d_trials)+"):"
print ("The transmission rate of " + " ".join(filename.split("/")[1].split("_"))  + " with input bit type " + str(input_bit_type) + " is listed below" + note_texts )
print (avg_trans_array[0])
print ("The error rate of " + " ".join(filename.split("/")[1].split("_"))  + " with input bit type " + str(input_bit_type) + " is listed below" + note_texts )
print (avg_error_array[0])
print ("The effective transmission rate of " + " ".join(filename.split("/")[1].split("_"))  + " with input bit type " + str(input_bit_type) + " is listed below" + note_texts )
print (avg_effec_array[0])


