#!/bin/bash

# Multi-threading (MT) misalignment-based attack

# Usage: see README (step 2) in the top level 
# Authors: 
# Shuwen Deng (shuwen.deng@yale.edu)
# Bowen Huang (bowen.huang@yale.edu)
# Jakub Szefer (jakub.szefer@yale.edu)

OUTPUTFILE=$1
INCSET=$2
AFFINITIY=$3 #now treated as affinity number
INPUT=$4
REPEATTIME=$5

echo "Start processing..."

set -o errexit
set -o xtrace
set -o nounset

prefix="acc"


SENDER=./tuning_parameters_set_uopnum_sender_0 
GPG=./tuning_parameters_set_uopnum_receiver 

postfix="_message.txt"
MESSAGEFILE="${OUTPUTFILE::${#OUTPUTFILE}-4}$postfix"

rm -f message.txt

echo $prefix\_total$INCSET\_set >> $OUTPUTFILE


LOOPNUM=2000 
INNERLOOP=200 #100 #250
ADDSET=27
dummy_number=FFFFFFF

echo $prefix\_$INCSET\_set1 >> $OUTPUTFILE
    for (( a = 1; a <= $REPEATTIME; a = a + 1 )) 
    do
        echo repeat_$a >> $OUTPUTFILE
        for (( INCSETINDEX = 1; INCSETINDEX <= $INCSET; INCSETINDEX = INCSETINDEX + 1 )) 
            do
                Rz=10
                Ro=14
                Rt=16
                Rh=24

                echo $prefix\_$INCSETINDEX\_Rz$Rz\_Ro$Ro\_Rt$Rt\_Rh$Rh\_$INNERLOOP\_$LOOPNUM\_$ADDSET >> $OUTPUTFILE 
                python2 modify_l1i_attack_v2.py 1 $INCSETINDEX 1 1 $Rz $Ro $Rt $Rh $ADDSET $AFFINITIY     
                
                cc -g -std=gnu99 -O0 -c -o tuning_parameters_set_uopnum_sender_0.o tuning_parameters_set_uopnum_receiver.c -O0 
                cc -g -o tuning_parameters_set_uopnum_sender_0 tuning_parameters_set_uopnum_sender_0.o -O0 -lpthread

                cc -g -std=gnu99 -O0 -c -o tuning_parameters_set_uopnum_receiver.o tuning_parameters_set_uopnum_receiver.c -O0 
                cc -g -o tuning_parameters_set_uopnum_receiver tuning_parameters_set_uopnum_receiver.o -O0 -lpthread         
                            
                sleep 0.1

                taskset -c 2 ${SENDER} sender $INPUT  & 
                PROBE_PID0=$!

                sleep 0.6 

                taskset -c $AFFINITIY perf stat -e idq.dsb_uops:u,idq.mite_uops:u,cycles:u,instructions:u -o asse_loop.txt ${GPG} receiver $INNERLOOP 0 0 $LOOPNUM 
                python process_perf_asse_loop.py $OUTPUTFILE $LOOPNUM $OUTPUTFILE 


                sleep 0.6
                kill -TERM ${PROBE_PID0} 
                sleep 0.1 

            done
    done
    
  

cp message.txt ${MESSAGEFILE}
