/*

Multi-threading (MT) misalignment-based attack

Usage: see README (step 2) in the top level 
Authors: 
Shuwen Deng (shuwen.deng@yale.edu)
Bowen Huang (bowen.huang@yale.edu)
Jakub Szefer (jakub.szefer@yale.edu)

*/
#define _GNU_SOURCE
#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/syscall.h>
#include <immintrin.h>
#include <x86intrin.h>
#include <pthread.h>
#include <assert.h>
#include <time.h>
#define gettid() syscall(SYS_gettid)
const int line_size=64;
const int way_size=64*64/8;
int g_stride=8;// next set

int para_d=4;
char sender_mode='a';
int Tone=20000;
int Tzero=20000;
int assist_funct_set1(void);
int assist_funct_set2(void);
//receiver
void * test_delay(uint64_t samples,uint64_t loops) { 
  
  uint32_t res_low=0, res_high=0, res2_low=0, res2_high=0;
  
  FILE * fp;
  char buff[255],buff2[255];
	fp = fopen ("run_temp.txt", "w");
    // insert nop1
  for (int loop_index = 0; loop_index < loops; loop_index++){ 
	  asm volatile (
	      "mfence\n"
	      "lfence\n");
  	asm volatile ("rdtscp": "=a" (res_low), "=d" (res_high) :: "ecx");
  	for (uint64_t i = 0; i < samples; /* Increment inside */) {
		asm __volatile (
			".byte 0xe9 \n"
			".byte 0x7b \n" //addr1
			".byte 0x02 \n" //addr2 
			".byte 0x00 \n" //addr3
			".byte 0x00 \n" //addr4 
		);
    	i++;
  	}
    asm volatile (
          "mfence\n"
          "lfence\n");
    asm volatile ("rdtscp": "=a" (res2_low), "=d" (res2_high) :: "ecx");
    uint64_t final=0,final2=0;
    final=(((uint64_t)res_high) << 32) | res_low;
    final2=(((uint64_t)res2_high) << 32) | res2_low;
    fprintf(fp, "%llu\n", final2-final);
  }
	fclose(fp);
  
    
  //return start;
}

void * sender(){ 
  // insert nop2
  // insert nop3
  int message[128] = {0,0,0,0, 1,0,1,0, 1,1,1,1, 0,1,0,1};
  FILE * fp_sender = fopen ("message.txt", "a");
  if(sender_mode== '0'){
      for(int i =0; i< 128; i++){
            message[i] = 0;
      }
  }
  else if(sender_mode== '1'){
      for(int i =0; i< 128; i++){
            message[i] = 1;
      }
  }
  else if(sender_mode== 'r'){
        for(int i = 16;i < 128;i++){
        message[i]= rand()%2;
      } //generate random message
  }else{ // mode == 'a'
        for(int i =0; i< 128; i++){
            message[i] = i%2;
        } 
  }
  printf("Message to be sent: ");
  for(int i = 0;i < 128;i++){
    printf("%d",message[i]);
  }
  printf("\n");
  fprintf(fp_sender, "Message to be sent: ");
  for(int i = 0;i < 128;i++){
    fprintf(fp_sender, "%d",message[i]);
  }
  fprintf(fp_sender, "\n");
  fclose(fp_sender);
  for (;;) 
  {    
      for(int i=0;i<128;i++){ 
        //send one 
          if(message[i]==1){     
             for (uint64_t i = 0; i < 2000/*10000*//*2500*//*100000*/; /* Increment inside */) { 
                // asm __volatile (
                //         ".byte 0xe9 \n"
                //         ".byte 0x7b \n" //addrX5 
                //         ".byte 0x02 \n" //addrX6 
                //         ".byte 0x00 \n" //addrX7
                //         ".byte 0x00 \n" //addrX8
                //     );
                i++;
            }
            // insert nop5
         }
       //send zero 
         else{
            for (uint64_t i = 0; i < 2000/*10000*//*2500*//*100000*/; /* Increment inside */) { 
                asm __volatile (
                        ".byte 0xe9 \n"
                        ".byte 0x7b \n" //addrA 
                        ".byte 0x02 \n" //addrB 
                        ".byte 0x00 \n" //addrC
                        ".byte 0x00 \n" //addrD
                    );
                i++;
            }
         }
      }
  }
  // insert nop4
}


int main(int argc, char *argv[]) {
    
  int Is_sender=0;
  uint64_t samples;
  if(argc <2) { printf("wrong configure! must choose between sender or receiver\n"); return -1;}
  if (strcmp(argv[1], "sender") == 0){
      Is_sender=1;
      if(argc <3) { printf("wrong configure! must choose sender mode, opetions: \n 0 (send 0),\n 1 (send 1),\n a (send 010101...),\n r (send random bits after a prefix).\n"); return -1;}
      sender_mode=argv[2][0];    
  }
  else if (strcmp(argv[1], "receiver") == 0){
      Is_sender=0;
     
      if(argc >= 3){
        samples=strtol(argv[2], NULL, 10);
        printf("samples=%d\n",samples);
      }  
      if(argc >= 4){
          para_d=strtol(argv[3], NULL, 10);
          printf("parameter d=%d\n",para_d);
      }
  } 
  else{ printf("wrong configure!\n"); return -1;}

  srand(1234);

  cpu_set_t victim_set;
  CPU_ZERO(&victim_set); 
  cpu_set_t attacker_set;
  CPU_ZERO(&attacker_set);
    
  //For example, cpu 2 and 8 are sharing one core for srv1 machine
  CPU_SET(2,&victim_set);
  CPU_SET(8,&attacker_set);
  
  
  printf("Parameters set\n");
  uint64_t loops = atoi(argv[5]);
  
   
  if(Is_sender){
    if(sched_setaffinity(gettid(),sizeof(cpu_set_t),&victim_set)==-1){
        printf("Can not set affinity\n");
        return 1;
    } 
    sender(); 
  }
  else{
     if(sched_setaffinity(gettid(),sizeof(cpu_set_t),&attacker_set)==-1){
        printf("Can not set affinity\n");
        return 1;
    }
    test_delay(samples, loops); 
  }

  return 0;
}

























