/*

Non multi-threading (non-MT) fast misalignment-based attack

Usage: see README (step 3) in the top level 
Authors: 
Shuwen Deng (shuwen.deng@yale.edu)
Bowen Huang (bowen.huang@yale.edu)
Jakub Szefer (jakub.szefer@yale.edu)

*/
#define _GNU_SOURCE             /* See feature_test_macros(7) */
#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>

#define PAGE_SIZE 4096
#define UOP_SET 32
#define UOP_ASSOCIATIVITY 8
#define UOP_CACHELINE 32

#include <sys/syscall.h>
#include <sys/sysinfo.h>
#include <unistd.h>
#include <sys/mman.h>

#include <fcntl.h>
#include <sched.h>

#include <time.h>
#define gettid() syscall(SYS_gettid)


int main(int ac, char **av) {
    uint32_t res_low=0, res_high=0, res2_low=0, res2_high=0;
  	uint64_t samples = 0;

  	samples = atoi(av[1]);

    FILE * fp;
    char buff[255],buff2[255];
	fp = fopen ("run_temp.txt", "w");
	// insert nop1
	asm volatile (
	      "mfence\n"
	      "lfence\n");
  	asm volatile ("rdtscp": "=a" (res_low), "=d" (res_high) :: "ecx");
  	for (uint64_t i = 0; i < samples; /* Increment inside */) {
		asm __volatile (
			".byte 0xe9 \n"
			".byte 0x7b \n" //addr1
			".byte 0x02 \n" //addr2
			".byte 0x00 \n" //addr3
			".byte 0x00 \n" //addr4
		);
        // insert nop2
        asm __volatile (
			".byte 0xe9 \n"
			".byte 0x7b \n" //addr5
			".byte 0x02 \n" //addr6
			".byte 0x00 \n" //addr7
			".byte 0x00 \n" //addr8
		);
    	i++;
  	}
	asm volatile (
	      "mfence\n"
	      "lfence\n");
	asm volatile ("rdtscp": "=a" (res2_low), "=d" (res2_high) :: "ecx");
	
   	uint64_t final=0,final2=0;
   	final=(((uint64_t)res_high) << 32) | res_low;
   	final2=(((uint64_t)res2_high) << 32) | res2_low;
    fprintf(fp, "%llu\n", final2-final);;
	// insert nop5
    uint64_t loops = atoi(av[2]);//256;//atoi(av[2]);
    for (int loop_index = 0; loop_index < loops; loop_index++){
    
	// insert nop3
	asm volatile (
	      "mfence\n"
	      "lfence\n");
  	asm volatile ("rdtscp": "=a" (res_low), "=d" (res_high) :: "ecx");
  	for (uint64_t i = 0; i < samples; /* Increment inside */) {
		asm __volatile (
			".byte 0xe9 \n"
			".byte 0x7b \n" //addr9
			".byte 0x02 \n" //addrA
			".byte 0x00 \n" //addrB
			".byte 0x00 \n" //addrC
		);
        // insert nop4
        // asm __volatile (
		// 	".byte 0xe9 \n"
		// 	".byte 0x7b \n" //addXrD
		// 	".byte 0x02 \n" //addXrE
		// 	".byte 0x00 \n" //addXrF
		// 	".byte 0x00 \n" //addXr0
		// );
    	i++;
  	}
	asm volatile (
	      "mfence\n"
	      "lfence\n");
	asm volatile ("rdtscp": "=a" (res2_low), "=d" (res2_high) :: "ecx");
   	final=(((uint64_t)res_high) << 32) | res_low;
   	final2=(((uint64_t)res2_high) << 32) | res2_low;
    fprintf(fp, "%llu\n", final2-final);
	
	// insert nop6

	// insert nop7
	asm volatile (
	      "mfence\n"
	      "lfence\n");
  	asm volatile ("rdtscp": "=a" (res_low), "=d" (res_high) :: "ecx");
  	for (uint64_t i = 0; i < samples; /* Increment inside */) {
		asm __volatile (
			".byte 0xe9 \n"
			".byte 0x7b \n" //addrG
			".byte 0x02 \n" //addrH
			".byte 0x00 \n" //addrI
			".byte 0x00 \n" //addrJ
		);
        asm __volatile (
			".byte 0xe9 \n"
			".byte 0x7b \n" //addrK
			".byte 0x02 \n" //addrL
			".byte 0x00 \n" //addrM
			".byte 0x00 \n" //addrN
		);
    	i++;
  	}
	asm volatile (
	      "mfence\n"
	      "lfence\n");
	asm volatile ("rdtscp": "=a" (res2_low), "=d" (res2_high) :: "ecx");
   	final=(((uint64_t)res_high) << 32) | res_low;
   	final2=(((uint64_t)res2_high) << 32) | res2_low;
    fprintf(fp, "%llu\n", final2-final);
	
	// insert nop8

    }
	
    fclose(fp); 

}

























