#!/bin/bash

# Non multi-threading (non-MT) stealthy eviction-based attack

# Usage: see README (step 3) in the top level 
# Authors: 
# Shuwen Deng (shuwen.deng@yale.edu)
# Bowen Huang (bowen.huang@yale.edu)
# Jakub Szefer (jakub.szefer@yale.edu)

OUTPUTFILE=$1
REPEATNUM=$2
LOOPNUM=$3 #250 
INNERLOOPVALUE=10 
IFMAKE=1
RUNNUM=1
WAYNUM=3
INCSET=1

echo "Start processing..."

set -o errexit
set -o xtrace
set -o nounset

prefix="acc"

a=1
echo $prefix\_$INCSET\_$RUNNUM >> $OUTPUTFILE
python2 modify_l1i_attack_single.py $RUNNUM $WAYNUM $INCSET 0 6 

if [ $IFMAKE -eq "1" ]
then
				
	cc -g -std=gnu99 -O0 -c -o tuning_parameters_set_uopnum_receiver.o tuning_parameters_set_uopnum_receiver.c -O0 
	cc -g -o tuning_parameters_set_uopnum_receiver tuning_parameters_set_uopnum_receiver.o -O0 -lpthread

fi
			
for (( i = 1; i <= $REPEATNUM; i = i + 1 )) 
do
	sleep 0.1
	echo repeat_$i >> $OUTPUTFILE
	taskset -c 3 perf stat -e cycles:u,instructions:u -o asse_loop.txt ./tuning_parameters_set_uopnum_receiver $INNERLOOPVALUE $LOOPNUM # 40 $LOOPNUM #5000000 #400 #5000000 #40000 #4000 #0000 # 1 #5000 #0000
	python process_perf_asse_loop_single.py $OUTPUTFILE $LOOPNUM
done
			
		

			





