#!/bin/bash

# SGX non multi-threading (non-MT) stealthy misalignment-based attack

# Usage: see README (step 5) in the top level 
# Authors: 
# Shuwen Deng (shuwen.deng@yale.edu)
# Bowen Huang (bowen.huang@yale.edu)
# Jakub Szefer (jakub.szefer@yale.edu)
OUTPUTFILE=$1 
REPEATTIME=$2 
LOOPNUM=$3  

INNERLOOPVALUE=5000 
RUNNUM=1 
WAYNUM=8
IFMAKE=1
INCSET=2 

echo "Start processing..."

set -o errexit
set -o xtrace
set -o nounset

prefix="acc"
a=1

echo $prefix\_$INCSET\_$RUNNUM >> $OUTPUTFILE
echo $prefix\_$WAYNUM\_$INCSET\_$RUNNUM\_0 >> $OUTPUTFILE

python2 modify_l1i_attack_single.py $RUNNUM $WAYNUM $INCSET 0 6 160 0 


if [ $IFMAKE -eq "1" ]
then
	make clean;make

fi

for (( i = 1; i <= $REPEATTIME; i = i + 1 )) 
do
	sleep 0.1
    echo repeat_$i >> $OUTPUTFILE

	perf stat -e cycles:u,instructions:u -o asse_loop.txt ./fnr
	python process_perf_asse_loop_single.py $OUTPUTFILE $LOOPNUM
done



